
FILE* flux_debug=NULL;
char glb_szNull[1]="";

//-----------------------------------------------------------------------------
TERROR_CODE Intf_odefin_StringType(	STDBInfo*	p_pDBInfo,
									int*		p_piIndex,
									char*		p_pszField,
									int			p_iSize,
									short*		p_psIndicator,
									short*		p_psRetCode,
									int			p_iFn,
									int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	#if DEBUG
		DebugTraceAndFlushIFDM_2P("Intf_odefin_StringType: p_pszField=%s: p_iSize=%d",p_pszField,(int)p_iSize);
		if	(p_psRetCode)
		{
			DebugTraceAndFlushIFDM_1P("Intf_odefin_StringType: p_psRetCode=%d\n",(int)(*p_psRetCode));
		}
		else
		{
			DebugTraceAndFlushIFDM("Intf_odefin_StringType: p_psRetCode=NULL\n");
		};
	#endif
	
	if(odefin(	&p_pDBInfo->m_cda,
				*p_piIndex,  		//	Index
				(ub1*)p_pszField,	//	Output Var
				sizeof(char)*(p_iSize),			//	Len
			    STRING_TYPE,		//	DataType
			    -1,					//	Scale
			    (sb2*)p_psIndicator,//	indp
			    (text*)0,			//	fmt
			    -1,					//	fmt1
			    -1,					//	fmtt
			    (ub2*)0,			//	ret1
			    (ub2*)p_psRetCode))			//	retcode
	{
		ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__ODEFIN);
		DebugTraceError(ErrorCode,p_pDBInfo);
	}
	else
		(*p_piIndex)++;
	return ErrorCode;
};

//-----------------------------------------------------------------------------
TERROR_CODE Intf_odefin_Code(	STDBInfo*	p_pDBInfo,
									int*		p_piIndex,
									char*		p_pszField,
									short*		p_psIndicator,
									short*		p_psRetCode,
									int			p_iFn,
									int			p_iGravite)
{
	DebugTraceAndFlushIFDM_2P("Intf_odefin_Code: p_pszField=%s: Size__Code=%d\n",p_pszField,(int)Size__Code);
	return Intf_odefin_StringType(	p_pDBInfo,
									p_piIndex,
									p_pszField,
									Size__Code,
									p_psIndicator,
									p_psRetCode,
									p_iFn,
									p_iGravite);
};

//-----------------------------------------------------------------------------
TERROR_CODE Intf_odefin_CharType(	STDBInfo*	p_pDBInfo,
									int*		p_piIndex,
									char*		p_pchField,
									short*		p_psIndicator,
									short*		p_psRetCode,
									int			p_iFn,
									int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	if(odefin(	&p_pDBInfo->m_cda,
				*p_piIndex,  		//	Index
				(ub1*)p_pchField,	//	Output Var
				sizeof(char),		//	Len
			    96,					//	DataType	CHAR_TYPE
			    -1,					//	Scale
			    (sb2*)p_psIndicator,//	indp
			    (text*)0,			//	fmt
			    -1,					//	fmt1
			    -1,					//	fmtt
			    (ub2*)0,			//	ret1
			    (ub2*)p_psRetCode))			//	retcode
	{
		ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__ODEFIN);
		DebugTraceError(ErrorCode,p_pDBInfo);
	}
	else
		(*p_piIndex)++;
	return ErrorCode;
};

//-----------------------------------------------------------------------------
TERROR_CODE Intf_odefin_LongType(	STDBInfo*	p_pDBInfo,
									int*		p_piIndex,
									long*		p_plField,
									short*		p_psIndicator,
									short*		p_psRetCode,
									int			p_iFn,
									int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	if(odefin(	&p_pDBInfo->m_cda,
				*p_piIndex,  		//	Index
				(ub1*)p_plField,	//	Output Var
				sizeof(long),		//	Len
			    INT_TYPE,			//	DataType
			    -1,					//	Scale
			    (sb2*)p_psIndicator,			//	indp
			    (text*)0,			//	fmt
			    -1,					//	fmt1
			    -1,					//	fmtt
			    (ub2*)0,			//	ret1
			    (ub2*)p_psRetCode))			//	retcode
	{
		ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__ODEFIN);
		DebugTraceError(ErrorCode,p_pDBInfo);
	}
	else
		(*p_piIndex)++;
	return ErrorCode;
};

//-----------------------------------------------------------------------------
TERROR_CODE Intf_odefin_IntType(	STDBInfo*	p_pDBInfo,
									int*		p_piIndex,
									int*		p_piField,
									short*		p_psIndicator,
									short*		p_psRetCode,
									int			p_iFn,
									int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	if(odefin(	&p_pDBInfo->m_cda,
				*p_piIndex,  		//	Index
				(ub1*)p_piField,	//	Output Var
				sizeof(int),		//	Len
			    INT_TYPE,			//	DataType
			    -1,					//	Scale
			    (sb2*)p_psIndicator,	//	indp
			    (text*)0,			//	fmt
			    -1,					//	fmt1
			    -1,					//	fmtt
			    (ub2*)0,			//	ret1
			    (ub2*)p_psRetCode))			//	retcode
	{
		ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__ODEFIN);
		DebugTraceError(ErrorCode,p_pDBInfo);
	}
	else
		(*p_piIndex)++;
	return ErrorCode;
};

//-----------------------------------------------------------------------------
TERROR_CODE Intf_odefin_FloatType(	STDBInfo*	p_pDBInfo,
									int*		p_piIndex,
									float*		p_pfltField,
									short*		p_psIndicator,
									short*		p_psRetCode,
									int			p_iFn,
									int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	if(odefin(	&p_pDBInfo->m_cda,
				*p_piIndex,  		//	Index
				(ub1*)p_pfltField,	//	Output Var
				sizeof(float),		//	Len
			    FLOAT_TYPE,			//	DataType
			    -1,					//	Scale
			    (sb2*)p_psIndicator,			//	indp
			    (text*)0,			//	fmt
			    -1,					//	fmt1
			    -1,					//	fmtt
			    (ub2*)0,			//	ret1
			    (ub2*)p_psRetCode))			//	retcode
	{
		ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__ODEFIN);
		DebugTraceError(ErrorCode,p_pDBInfo);
	}
	else
		(*p_piIndex)++;
	return ErrorCode;
};

//-----------------------------------------------------------------------------
TERROR_CODE Intf_obndrv_StringType(	STDBInfo*	p_pDBInfo,
									char*		p_pszFieldName,
									char*		p_pszField,
									int			p_iSize,
									int			p_iFn,
									int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	DebugTraceAndFlushIFDM_2P("Intf_obndrv_StringType: p_pszFieldName=%s: p_pszField=%s\n",p_pszFieldName,p_pszField);
	if(obndrv(	&p_pDBInfo->m_cda,
				(text*)p_pszFieldName,  	//	FieldName
				-1,
				(ub1*)p_pszField,	//	Input Var
				p_iSize,			//	Len
			    STRING_TYPE,		//	DataType
			    -1,					//	Scale
			    (sb2*)0,			//	indp
			    (text*)0,			//	fmt
			    -1,					//	fmt1
			    -1))			//	retcode
	{
		ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__OBNDRV);
		DebugTraceError(ErrorCode,p_pDBInfo);
	};
	return ErrorCode;
};

//-----------------------------------------------------------------------------
TERROR_CODE Intf_obndrv_IntType(STDBInfo*	p_pDBInfo,
								char*		p_pszFieldName,
								int* 		p_piField,
								int 		p_iFn,
								int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	DebugTraceAndFlushIFDM_2P("Intf_obndrv_IntType: p_pszFieldName=%s: p_piField=%d\n",p_pszFieldName,*p_piField);
	if(obndrv(	&p_pDBInfo->m_cda,
				(text*)p_pszFieldName,  	//	FieldName
				-1,
				(ub1*)p_piField,	//	Input Var
				sizeof(int),		//	Len
			    INT_TYPE,			//	DataType
			    -1,					//	Scale
			    (sb2*)0,			//	indp
			    (text*)0,			//	fmt
			    -1,					//	fmt1
			    -1))				//	retcode
	{
		ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__OBNDRV);
		DebugTraceError(ErrorCode,p_pDBInfo);
	};
	return ErrorCode;
};

//-----------------------------------------------------------------------------
TERROR_CODE Intf_obndrv_LongType(	STDBInfo*	p_pDBInfo,
									char*		p_pszFieldName,
									long* 		p_plField,
									int 		p_iFn,
									int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	DebugTraceAndFlushIFDM_2P("Intf_obndrv_LongType: p_pszFieldName=%s: p_plField=%ld\n",p_pszFieldName,*p_plField);
	if(obndrv(	&p_pDBInfo->m_cda,
				(text*)p_pszFieldName,  	//	FieldName
				-1,
				(ub1*)p_plField,	//	Input Var
				sizeof(long),			//	Len
			    INT_TYPE,		//	DataType
			    -1,					//	Scale
			    (sb2*)0,			//	indp
			    (text*)0,			//	fmt
			    -1,					//	fmt1
		    	-1))			//	retcode
	{
		ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__OBNDRV);
		DebugTraceError(ErrorCode,p_pDBInfo);
	};
	return ErrorCode;
};
			
//-----------------------------------------------------------------------------
TERROR_CODE Intf_obndrv_FloatType(	STDBInfo*	p_pDBInfo,
									char*		p_pszFieldName,
									float* 		p_pfltField,
/*									int			p_iMM,	//	Total Nb of Digits
									int			p_iNN,	//	Decimal Digits
*/
									int 		p_iFn,
									int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
//	char	szFormat[50];
//	sprintf(szFormat,"%2.2d.+%2.2d",p_iMM,p_iNN);
	DebugTraceAndFlushIFDM_2P("Intf_obndrv_FloatType: p_pszFieldName=%s: p_pfltField=%f\n",p_pszFieldName,*p_pfltField);
	if(obndrv(	&p_pDBInfo->m_cda,
				(text*)p_pszFieldName,  	//	FieldName
				-1,
				(ub1*)p_pfltField,	//	Input Var
				sizeof(float),		//	Len
			    FLOAT_TYPE,			//	DataType
			    -1,					//	Scale
			    (sb2*)0,			//	indp
			    (text*)0,			//	fmt
			    -1,					//	fmt1
/*			    szFormat,			//	fmt
			    strlen(szFormat),	//	fmt1
*/
		    	-1))				//	retcode
	{
		ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__OBNDRV);
		DebugTraceError(ErrorCode,p_pDBInfo);
	};
	return ErrorCode;
};

//-----------------------------------------------------------------------------
//	Retourne dans p_pszSeqRet un nouveau numro dans la squence p_pszSeqName
TERROR_CODE GetNextValFor(	char*		p_pszSeqRet,
							STDBInfo*	p_pDBInfo,
							char*		p_pszSeqName,
							int			p_iFn,
							int			p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	char	szRequete[Size__Requete];
	long	lSeq=0;
	int		iIndex=1;

	//	Le n est vid
	p_pszSeqRet[0]=0;

	//	Formatage de la requete
	sprintf(szRequete,"select %s.nextval  from dual",p_pszSeqName);
	DebugTraceAndFlushIFDM_1P("GetNextValFor(): requete=%s\n",szRequete);

	//	Ouverture du curseur
	ErrorCode=OpenDBCurseur(p_pDBInfo,p_iGravite);
	if	(!IsError(ErrorCode))
	{
		//	Parse de la requete
		DebugTraceAndFlushIFDM("GetNextValFor() Avant OPARSE\n");
		if(oparse(&p_pDBInfo->m_cda,szRequete,-1,0,2))
		{
			ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__OPARSE);
			DebugTraceError(ErrorCode,p_pDBInfo);
		};
		DebugTraceAndFlushIFDM("GetNextValFor() Aprs OPARSE\n");

		if	(!IsError(ErrorCode))
		{
			iIndex=1;
			//	Bind des donnes
			ErrorCode=Intf_odefin_LongType(p_pDBInfo,&iIndex,&lSeq,NULL,NULL,p_iFn,p_iGravite);
			if	(!IsError(ErrorCode))
			{
				//	Execution de la requete
				DebugTraceAndFlushIFDM("GetNextValFor() Avant OEXEC\n");
				if(oexec(&p_pDBInfo->m_cda))
				{
					ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__OXEC);
					DebugTraceError(ErrorCode,p_pDBInfo);
				}
				else
				{
					//	Fetch de la donne
					DebugTraceAndFlushIFDM("GetNextValFor() Aprs OEXEC\n");
					DebugTraceAndFlushIFDM("GetNextValFor() Avant OFETCH\n");
					if(ofetch(&p_pDBInfo->m_cda))
					{
						//	Erreur
						ErrorCode=MakeErrorCode(p_iFn,p_iGravite,ERROR__OFETCH);
						DebugTraceError(ErrorCode,p_pDBInfo);
					}
					else
					{
						//	OK, on met le rsultat dans p_pszSeqRet
						DebugTraceAndFlushIFDM_1P("GetNextValFor(): lSeq=%ld\n",lSeq);
						sprintf(p_pszSeqRet,"%ld",lSeq);
						DebugTraceAndFlushIFDM_1P("GetNextValFor(): p_pszSeqRet=%s\n",p_pszSeqRet);
					};
					DebugTraceAndFlushIFDM("GetNextValFor() Aprs OFETCH\n");
				};
			};
		};
		//	Fereture du curseur
		ErrorCode=CloseDBCurseur(p_pDBInfo,p_iGravite,ErrorCode);
	};
	return ErrorCode;
};

//-----------------------------------------------------------------------------
//	Ouverture de la base (ologon)
TERROR_CODE OpenDB(STDBInfo* p_pDBInfo,int p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	DebugTraceAndFlushIFDM("OpenDB()\n");
	ErrorCode=CloseDBIFND(p_pDBInfo,p_iGravite);
	if	(!IsError(ErrorCode))
	{
    	InitStruct(p_pDBInfo->m_lda);
    	InitStruct(p_pDBInfo->m_cda);
    	memset(p_pDBInfo->m_hda,0,sizeof(p_pDBInfo->m_hda));
		//if(olog(&lda,hda,(text*)"TheDataBase",-1,(text*)0,-1,(text*)0,-1,OCI_LM_DEF))
	    if	(orlon(&p_pDBInfo->m_lda,p_pDBInfo->m_hda,(text*)p_pDBInfo->m_szName,-1,(text*)0,-1,0))
		{
			ErrorCode=MakeErrorCode(FN_OpenDB,p_iGravite,ERROR__OUVERTURE_DB);
			DebugTraceError(ErrorCode,p_pDBInfo);
		}
		else
		{
			p_pDBInfo->m_fOpen=TRUE;
			DebugTraceAndFlushIFDM("OpenDB(): OK\n");
			DebugTraceAndFlushIFDM_1P("OpenDB(): p_pDBInfo=%ld\n",(long)p_pDBInfo);
			DebugTraceAndFlushIFDM_1P("OpenDB(): CheckSum=%lu\n",GetCheckSum((void*)p_pDBInfo,sizeof(STDBInfo)));
		};
    };
    return ErrorCode;
};

//	Fermeture de la base
TERROR_CODE CloseDBIFND(STDBInfo* p_pDBInfo,int p_iGravite)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	DebugTraceAndFlushIFDM("CloseDBIFND !! : CloseCursor()\n");
	ErrorCode=CloseDBCurseur(p_pDBInfo,p_iGravite,ErrorCode);
	DebugTraceAndFlushIFDM("CloseDBIFND !! : Apres CloseCursor()\n");
	if	(		p_pDBInfo
			&&	p_pDBInfo->m_fOpen
		)
	{
		DebugTraceAndFlushIFDM("CloseDBIFND: Really Close\n");
		if	(ologof(&p_pDBInfo->m_lda))
	    {
			DebugTraceAndFlushIFDM("CloseDBIFND !! : Erreur ologof\n");
			ErrorCode=MakeErrorCode(FN_CloseDBIFND,p_iGravite,ERROR__FERMETURE_DB);
			DebugTraceError(ErrorCode,p_pDBInfo);
	    }
	    else
	    {
			DebugTraceAndFlushIFDM("CloseDBIFND !! : apres ologof\n");
			p_pDBInfo->m_fOpen=FALSE;
	    	InitStruct(p_pDBInfo->m_lda);
    		InitStruct(p_pDBInfo->m_cda);
    		memset(p_pDBInfo->m_hda,0,sizeof(p_pDBInfo->m_hda));
	    };
	};
    return ErrorCode;
};

//-----------------------------------------------------------------------------
//	Ouverture du curseur
TERROR_CODE OpenDBCurseur(STDBInfo* p_pDBInfo,int p_iGravite)
{
	TERROR_CODE ErrorCode=CloseDBCurseur(p_pDBInfo,p_iGravite,ERROR__NO_ERROR);
	DebugTraceAndFlushIFDM("OpenDBCurseur()\n");
	DebugTraceAndFlushIFDM_1P("OpenDB(): CheckSum=%lu\n",GetCheckSum((void*)p_pDBInfo,sizeof(STDBInfo)));
	if	(!IsError(ErrorCode))
	{
		DebugTraceAndFlushIFDM_1P("OpenDBCurseur(): p_pDBInfo=%ld\n",(long)p_pDBInfo);
		DebugTraceAndFlushIFDM_1P("OpenDBCurseur(): &p_pDBInfo->m_cda=%ld\n",(long)&p_pDBInfo->m_cda);
		DebugTraceAndFlushIFDM_1P("OpenDBCurseur(): &p_pDBInfo->m_lda=%ld\n",(long)&p_pDBInfo->m_lda);
		DebugTraceAndFlushIFDM_1P("CheckSum=%lu\n",GetCheckSum((void*)p_pDBInfo,sizeof(STDBInfo)));
		if	(oopen(&p_pDBInfo->m_cda,&p_pDBInfo->m_lda,0,-1,-1,(text*)0,-1))	//(text*)0: UID
	    {
			ErrorCode=MakeErrorCode(FN_OpenDBIFND,p_iGravite,ERROR__OUVERTURE_CURSEUR);
			DebugTraceAndFlushIFDM_1P("CheckSum=%lu\n",GetCheckSum((void*)p_pDBInfo,sizeof(STDBInfo)));
			DebugTraceError(ErrorCode,p_pDBInfo);
	    }
	    else
	    {
			DebugTraceAndFlushIFDM_1P("CheckSum=%lu\n",GetCheckSum((void*)p_pDBInfo,sizeof(STDBInfo)));
			DebugTraceAndFlushIFDM("OpenDBCurseur(): OK\n");
			p_pDBInfo->m_fCursorOpen=TRUE;
	    };
	};
	return ErrorCode;
};

//-----------------------------------------------------------------------------
//	Fermeture du curseur
TERROR_CODE CloseDBCurseur(STDBInfo* p_pDBInfo,int p_iGravite,TERROR_CODE p_PrevErrorCode)
{
	TERROR_CODE ErrorCode=ERROR__NO_ERROR;
	DebugTraceAndFlushIFDM("CloseDBCurseur(): entree\n");
	ASSERT(p_pDBInfo,"CloseDBCurseur:p_pDBInfo");
	DebugTraceAndFlushIFDM_1P("CheckSum=%lu\n",GetCheckSum((void*)p_pDBInfo,sizeof(STDBInfo)));
	if	(		p_pDBInfo
			&&	p_pDBInfo->m_fCursorOpen
		)
	{
		DebugTraceAndFlushIFDM("CloseDBCurseur(): ooclose\n");
		if	(oclose(&p_pDBInfo->m_cda))
	    {
			ErrorCode=MakeErrorCode(FN_CloseDBIFND,p_iGravite,ERROR__FERMETURE_CURSEUR);
			DebugTraceError(ErrorCode,p_pDBInfo);
	    }
	    else
	    {
			DebugTraceAndFlushIFDM_1P("CheckSum=%lu\n",GetCheckSum((void*)p_pDBInfo,sizeof(STDBInfo)));
			DebugTraceAndFlushIFDM("CloseDBCurseur(): OK\n");
			p_pDBInfo->m_fCursorOpen=FALSE;
	    	InitStruct(p_pDBInfo->m_cda);
	    };
	};
	if	(IsError(p_PrevErrorCode))
	    return p_PrevErrorCode;
	else
	    return ErrorCode;
};

//-----------------------------------------------------------------------------
//	Retourne un pointeur sur le message correspondant  p_ErrorCode
char* GetErrorMsg(TERROR_CODE p_ErrorCode)
{
	char* pszMsg=glb_szNull;
/*
	int i=0;
	for(i=0;i<GetElementsNb(glb_Errors);i++)
	{
		DebugTraceAndFlushIFDM_2P("Error %d: %s\n",i,glb_Errors[i]);
	};
*/
	if	(p_ErrorCode<0)
	{
		if	((-GetErrorFromErrorCode(p_ErrorCode))<GetElementsNb(glb_Errors))
			pszMsg=glb_Errors[-GetErrorFromErrorCode(p_ErrorCode)];
		else
		{
			DebugTraceAndFlushIFDM_1P("Mauvaise Erreur !=%ld\n",(long)GetErrorFromErrorCode(p_ErrorCode));
		};
	}
	else
	{
		if	(GetErrorFromErrorCode(p_ErrorCode)<GetElementsNb(glb_Warnings))
			pszMsg=glb_Warnings[GetErrorFromErrorCode(p_ErrorCode)];
		else
		{
			DebugTraceAndFlushIFDM_1P("Mauvais Warning !=%ld\n",(long)GetErrorFromErrorCode(p_ErrorCode));
		};
	};
	DebugTraceAndFlushIFDM_1P("MsgErreur=[%s]\n",pszMsg ? pszMsg :"NULL");
	return pszMsg;
};

TERROR_CODE Marchand_Rechercher(STMarchand* p_pMarchand,BOOL p_fByName)
{
	TERROR_CODE ErreurCode=ERROR__NO_ERROR;
	DebugTraceAndFlushIFDM("Marchand_Rechercher\n");

	//	On va geberer une erreur si:
	//		le nom du marchand est vide (dans le case d'une recherche par nom)
	//		le code du marchand est vide (dans le case d'une recherche par code)
	if	(p_fByName)
	{
		if	(strlen(p_pMarchand->m_szNom)==0)
			ErreurCode=MakeErrorCode(FN_Marchand_Rechercher,*glb_piGravite,ERROR__NOM_MARCHAND_VIDE);
	}
	else if	(strlen(p_pMarchand->m_szCode)==0)
		ErreurCode=MakeErrorCode(FN_Marchand_Rechercher,*glb_piGravite,ERROR__CODE_MARCHAND_VIDE);

	if	(!IsError(ErreurCode))
	{
		char	szRequete[Size__Requete]	=	"";
		char	szTmp[Size__Requete]		=	"";
		int		i							=	0;
		int		iIndex						=	1;
		short	sIndicators[30];

		InitStruct(sIndicators);

		//	-----------------------------------------------
		//	----------------------- Formatage de la requete
		DebugTraceAndFlushIFDM("Sprintf Requete\n");
		DebugTraceAndFlushIFDM_1P("p_fByName=%d\n",p_fByName);
		DebugTraceAndFlushIFDM_1P("TABLE_NOM__MARCHAND=%s\n",glb_szNomTable__Marchands);
		DebugTraceAndFlushIFDM_1P("p_fByName ? Nom : Code=%s\n",p_fByName ? "Nom" : "Code");
		DebugTraceAndFlushIFDM_1P("p_fByName ? p_pMarchand->m_szNom : p_pMarchand->m_szCode=%s\n",p_fByName ? p_pMarchand->m_szNom : p_pMarchand->m_szCode);
		sprintf(szRequete,
				"select Code,Nom,Pays,RIBDomiciliation,RIBCodeBanque,RIBCodeGuichet,RIBCompteNo,RIBCleRib,EMailProblemes,TypeTableProduit,NomFichierDriver,HostTableProduit,DeviseRemise,MKServeurAddr,MontantURL from %s where %s = '%s'",
				glb_szNomTable__Marchands,
				(p_fByName ? "Nom" : "Code"),
				(p_fByName ? p_pMarchand->m_szNom : p_pMarchand->m_szCode));

		//	-----------------------------------------------
		//	----------------------- Open Cursor
		DebugTraceAndFlushIFDM("Open Cursor\n");
		ErreurCode=OpenDBCurseur(glb_pDBInfo,*glb_piGravite);
		if	(!IsError(ErreurCode))
		{
			if(oparse(&glb_pDBInfo->m_cda,szRequete,-1,0,2))
			{
				//	Echec OPARSE
				ErreurCode=MakeErrorCode(FN_Marchand_Rechercher,*glb_piGravite,ERROR__OPARSE);
				DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
			};

			if	(!IsError(ErreurCode))
			{
				//	Passage des donnes  rcuperer
				iIndex=1;
				ErreurCode=Intf_odefin_Code(glb_pDBInfo,&iIndex,p_pMarchand->m_szCode,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_szNom,Marchand_Size__Nom,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_szPays,Marchand_Size__Pays,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_stRIB.m_szDomiciliation,RIB_Size__Domiciliation,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_stRIB.m_szCodeBanque,RIB_Size__CodeBanque,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_stRIB.m_szCodeGuichet,RIB_Size__CodeGuichet,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_stRIB.m_szCompteNo,RIB_Size__CompteNo,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_stRIB.m_szCleRib,RIB_Size__CleRib,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_szEMailProblemes,Size__EMail,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_CharType(glb_pDBInfo,&iIndex,&p_pMarchand->m_chTypeTableProduit,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_szNomFichierDriver,Marchand_Size__NomFichierDriver,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_szHostTableProduit,Marchand_Size__HostTableProduit,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_szDeviseRemise,Size__Devise,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_szMKServeurAddr,Size__MKServeurAddr,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_StringType(glb_pDBInfo,&iIndex,p_pMarchand->m_szMontantURL,Size__URL,&sIndicators[iIndex],NULL,FN_Marchand_Rechercher,*glb_piGravite);
				

				if	(!IsError(ErreurCode))
				{
					//	Execution de la requete
					if(oexec(&glb_pDBInfo->m_cda))
					{
						//	Erreur OEXEC
						ErreurCode=MakeErrorCode(FN_Marchand_Rechercher,*glb_piGravite,ERROR__OXEC);
						DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
					}
					else
					{
						//	Fetch des donnes
						if(ofetch(&glb_pDBInfo->m_cda))
						{
							if	(glb_pDBInfo->m_cda.rc==NO_DATA_FOUND)
							{
								//	Pas de donnes
								DebugTraceAndFlushIFDM("Marchand_Rechercher: Pas produit demande\n");
								ErreurCode=MakeErrorCode(FN_Marchand_Rechercher,*glb_piGravite,ERROR__MARCHAND_INEXISTANT);
								DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
							}
							else
							{
								//	Erreur Fetch
								ErreurCode=MakeErrorCode(FN_Marchand_Rechercher,*glb_piGravite,ERROR__OFETCH);
								DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
							};
						}
						else
						{
							if	(glb_pDBInfo->m_cda.rc==NO_DATA_FOUND)
							{
								//	Pas de donnes
								DebugTraceAndFlushIFDM("Marchand_Rechercher: Pas produit demande\n");
								ErreurCode=MakeErrorCode(FN_Marchand_Rechercher,*glb_piGravite,ERROR__MARCHAND_INEXISTANT);
								DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
							}
							else
							{
								//	On a obtenu les donnes du marchand
								DebugTraceAndFlushIFDM("Marchand Trouve\n");
								DebugTraceAndFlushIFDM_1P("Code = %s\n",p_pMarchand->m_szCode);
								DebugTraceAndFlushIFDM_1P("Nom = %s\n",p_pMarchand->m_szNom);
								DebugTraceAndFlushIFDM_1P("Pays = %s\n",p_pMarchand->m_szPays);
							};
						};
					};
				};
			};
			ErreurCode=CloseDBCurseur(glb_pDBInfo,*glb_piGravite,ErreurCode);
		};
	};
	return ErreurCode;
};

//-----------------------------------------------------------------------------
//	Recherche d'un marchand et d'un produit dans la base
//	En entre:
//		p_pszCodeMarchand et p_pszCodeProduit doivent tre renseigns
//		Si p_pstMarchandRet->m_szCode contient le meme code que p_pszCodeMarchand
//				et si p_pstMarchandRet->m_szNom n'est pas vide
//				et si p_pstMarchandRet->m_chTypeTableProduit!=0
//			On recherche le marchand, autrement on considere que p_pstMarchandRet est dja renseign
//		Si 	p_pTableProduitPtrRet->m_pMarchand==p_pstMarchandRet
//				et si p_pTableProduitPtrRet->m_pHandleLibrairie n'est pas null
//				et si p_pTableProduitPtrRet->m_pFnRechercher n'est pas null
//			On recherche la table produit, autrement  on considere que p_pTableProduitPtrRet est dja renseign
//
//	En Sortie:
//		Si pas d'erreur: p_pstMarchandRet, p_pProduitRet et p_pTableProduitPtrRet sont renseigns
//	Note:
//		Appelle:
//			Marchand_Rechercher
//			TableProduit_ChargerLibrairie
//			Produit_Rechercher
//	Erreurs possibles spcifiques: aucune
TERROR_CODE MarchandProduit_Rechercher(STMarchand* p_pstMarchandRet,STProduit* p_pProduitRet,STTableProduitPtr* p_pTableProduitPtrRet,const char*	p_pszCodeMarchand,const char* p_pszCodeProduit)
{
	TERROR_CODE ErreurCode=ERROR__NO_ERROR;
	//	Rechercher marchand ? Ou est-il dj bon ?
	BOOL	fRechercherMarchand=		strcmp(p_pstMarchandRet->m_szCode,p_pszCodeMarchand)!=0
									||	strlen(p_pstMarchandRet->m_szNom)==0
									||	p_pstMarchandRet->m_chTypeTableProduit==0;

	//	---------------------------------------------------
	//	--------------- Recherche du marchand si ncessaire
	if	(fRechercherMarchand)
	{
		InitStructByPtr(p_pstMarchandRet,STMarchand);
		strcpy(p_pstMarchandRet->m_szCode,p_pszCodeMarchand);
		DebugTraceAndFlushIFDM("Rechercher Marchand()\n");
		ErreurCode=Marchand_Rechercher(p_pstMarchandRet,FALSE);	//	Par Code
		DebugTraceAndFlushIFDM("Fin Rechercher Marchand()\n");
	};

	if	(!IsError(ErreurCode))
	{
		BOOL	fRechercherTableProduit=		p_pTableProduitPtrRet->m_pMarchand!=p_pstMarchandRet
											||	!p_pTableProduitPtrRet->m_pHandleLibrairie
											||	!p_pTableProduitPtrRet->m_pFnRechercher;

		//	-----------------------------------------------
		//	------------ Chargement du driver table produit
		if	(fRechercherTableProduit)
		{
			InitStructByPtr(p_pTableProduitPtrRet,STTableProduitPtr);
			p_pTableProduitPtrRet->m_pMarchand=p_pstMarchandRet;
			DebugTraceAndFlushIFDM("TableProduit_ChargerLibrairie()\n");
			ErreurCode=TableProduit_ChargerLibrairie(p_pTableProduitPtrRet);
			DebugTraceAndFlushIFDM("Fin TableProduit_ChargerLibrairie()\n");
		};
	};

	if	(!IsError(ErreurCode))
	{
		//	-----------------------------------------------
		//	-------------------------- Recherche du produit
		InitStructByPtr(p_pProduitRet,STProduit);
		strcpy(p_pProduitRet->m_szCode,p_pszCodeProduit);
		DebugTraceAndFlushIFDM("Produit_Rechercher()\n");
		ErreurCode=Produit_Rechercher(p_pProduitRet,p_pTableProduitPtrRet);
		DebugTraceAndFlushIFDM("Fin Produit_Rechercher()\n");
	};

	return ErreurCode;
};

TERROR_CODE Paiement_Rechercher(STPaiement* p_pstPaiementRet,const char* p_pszCodeMarchand,EPaiType p_eTypePaiement)
{
	TERROR_CODE ErreurCode=ERROR__NO_ERROR;
	DebugTraceAndFlushIFDM("Paiement_Rechercher\n");

	//	On va generer une erreur si:
	//		le code du marchand est vide
	if	(strlen(p_pszCodeMarchand)==0)
		ErreurCode=MakeErrorCode(FN_Paiement_Rechercher,*glb_piGravite,ERROR__CODE_MARCHAND_VIDE);

	if	(!IsError(ErreurCode))
	{
		char	szRequete[Size__Requete]	=	"";
		char	szTmp[Size__Requete]		=	"";
		int		i							=	0;
		int		iIndex						=	1;
		short	sIndicators[30];

		InitStruct(sIndicators);

		//	-----------------------------------------------
		//	----------------------- Formatage de la requete
		DebugTraceAndFlushIFDM("Sprintf Requete\n");
		sprintf(szRequete,
				"select CodeMarchand,TypePaiement,CommissionPourCent,CommissionPlancher,Minimum from %s where CodeMarchand = '%s' AND TypePaiement = %d",
				glb_szNomTable__Paiements,
				p_pszCodeMarchand,
				(int)p_eTypePaiement);

		//	-----------------------------------------------
		//	----------------------- Open Cursor
		DebugTraceAndFlushIFDM("Open Cursor\n");
		ErreurCode=OpenDBCurseur(glb_pDBInfo,*glb_piGravite);
		if	(!IsError(ErreurCode))
		{
			if(oparse(&glb_pDBInfo->m_cda,szRequete,-1,0,2))
			{
				//	Echec OPARSE
				ErreurCode=MakeErrorCode(FN_Paiement_Rechercher,*glb_piGravite,ERROR__OPARSE);
				DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
			};

			if	(!IsError(ErreurCode))
			{
				//	Passage des donnes  rcuperer
				iIndex=1;
				ErreurCode=Intf_odefin_Code(glb_pDBInfo,&iIndex,p_pstPaiementRet->m_szCodeMarchand,&sIndicators[iIndex],NULL,FN_Paiement_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_IntType(glb_pDBInfo,&iIndex,(int*)&p_pstPaiementRet->m_eTypePaiement,&sIndicators[iIndex],NULL,FN_Paiement_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_FloatType(glb_pDBInfo,&iIndex,&p_pstPaiementRet->m_fltCommissionPourcentage,&sIndicators[iIndex],NULL,FN_Paiement_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_FloatType(glb_pDBInfo,&iIndex,&p_pstPaiementRet->m_fltCommissionPlancher,&sIndicators[iIndex],NULL,FN_Paiement_Rechercher,*glb_piGravite);
				if	(!IsError(ErreurCode))
					ErreurCode=Intf_odefin_FloatType(glb_pDBInfo,&iIndex,&p_pstPaiementRet->m_fltMinimum,&sIndicators[iIndex],NULL,FN_Paiement_Rechercher,*glb_piGravite);

				if	(!IsError(ErreurCode))
				{
					//	Execution de la requete
					if(oexec(&glb_pDBInfo->m_cda))
					{
						//	Erreur OEXEC
						ErreurCode=MakeErrorCode(FN_Paiement_Rechercher,*glb_piGravite,ERROR__OXEC);
						DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
					}
					else
					{
						//	Fetch des donnes
						if(ofetch(&glb_pDBInfo->m_cda))
						{
							//	Erreur Fetch
							ErreurCode=MakeErrorCode(FN_Paiement_Rechercher,*glb_piGravite,ERROR__OFETCH);
							DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
						}
						else
						{
							if	(glb_pDBInfo->m_cda.rc==NO_DATA_FOUND)
							{
								//	Pas de donnes
								DebugTraceAndFlushIFDM("Paiement_Rechercher: Pas Paiement\n");
								ErreurCode=MakeErrorCode(FN_Paiement_Rechercher,*glb_piGravite,ERROR__PAIEMENT_INEXISTANT);
								DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
							}
							else
							{
								//	On a obtenu les donnes du marchand
								DebugTraceAndFlushIFDM("Paiement Trouve\n");
							};
						};
					};
				};
			};
			ErreurCode=CloseDBCurseur(glb_pDBInfo,*glb_piGravite,ErreurCode);
		};
	};
	return ErreurCode;
};


TERROR_CODE Transaction_AjouterNouvelle(STTransaction*		p_pTransaction,
										int					p_iProduitsNb,
										STProduitPartie*	p_pProduits,
										const STPaiement*	p_pPaiement)
{
	TERROR_CODE ErreurCode=ERROR__NO_ERROR;
	char	szRequete[Size__Requete]	=	"";
	char	szTmp[Size__Requete]		=	"";
	char	szValues[Size__Requete]		=	"";
	int 	i=0;
	float	fltPrixHT		=	0;
	float	fltTotalPrixHT	=	0;
	float	fltTotalPrixTTC	=	0;
	DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle()\n");

	//	---------------------------------------------------
	//	----------------------- Acte I: Ajouter Transaction

	//	On demande un nouveau n de transaction
	DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Avant GetNextValFor\n");
	ErreurCode=GetNextValFor(	p_pTransaction->m_szCode,
								glb_pDBInfo,
								glb_szNomSeq__Transaction,
								FN_Transaction_AjouterNouvelle,*glb_piGravite);
	DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Aprs GetNextValFor\n");


	//	Prix
	for(i=0;i<p_iProduitsNb;i++)
	{
		DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle: p_pProduits[i].m_fltPrixTTC=%f\n",p_pProduits[i].m_fltPrixTTC);
		DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle: p_pProduits[i].m_iQuantite=%d\n",p_pProduits[i].m_iQuantite);
		fltTotalPrixTTC+=p_pProduits[i].m_fltPrixTTC*p_pProduits[i].m_iQuantite;
		DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle: p_pProduits[i].m_iCodeTVA=%d\n",p_pProduits[i].m_iCodeTVA);
		fltPrixHT=TTC2HT(p_pProduits[i].m_fltPrixTTC*p_pProduits[i].m_iQuantite,p_pProduits[i].m_iCodeTVA);
		DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle: fltPrixHT=%f\n",fltPrixHT);
		fltTotalPrixHT+=fltPrixHT;
	};
	DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle: fltTotalPrixTTC=%f\n",fltTotalPrixTTC);
	DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle: fltTotalPrixHT=%f\n",fltTotalPrixHT);

	if	(p_pPaiement)
	{
		if	(fltTotalPrixTTC<p_pPaiement->m_fltMinimum)
		{
			ErreurCode=MakeErrorCode(FN_Transaction_AjouterNouvelle,*glb_piGravite,ERROR__MONTANT_TROP_PETIT);
			DebugTraceErrorMacro(ErreurCode,NULL);
		};
	};

	if	(!IsError(ErreurCode))
	{
		char	szTimeBuffer[Size__TimeString]	=	"";
		char	szFields[]	=	"Code,CodeMarchand,CodeClient,CodeClientPaitype,TypePaiement,DateDebut,Etat,CodeErreur,PrixTTC,PrixHT,Devise,Caddie,RefMarchandAppel";

		//	On transforme le n de transaction en code transaction (caractres)
		PadCode(p_pTransaction->m_szCode);
		DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() p_pTransaction->m_szCode=%s\n",p_pTransaction->m_szCode);

		//	On renseigne les informations transaction
		p_pTransaction->m_DateDebut	=	time(NULL);
		p_pTransaction->m_chEtat	=	TransactionEtat__Inconnu;
		p_pTransaction->m_CodeErreur=	0;
		p_pTransaction->m_fltPrixTTC=	fltTotalPrixTTC;
		p_pTransaction->m_fltPrixHT	=	fltTotalPrixHT;

		DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle Etat = %c\n",p_pTransaction->m_chEtat);

		GetTimeString(szTimeBuffer,p_pTransaction->m_DateDebut),

		//	Formatage de la requte
		sprintf(szValues,"'%s','%s','%s','%s','%d',to_date('%s','YYYY/MM/DD HH24:MI:SS'),'%c',%ld,%.2f,%.2f,'%s','%c','%s'",
				p_pTransaction->m_szCode,
				p_pTransaction->m_szCodeMarchand,
				p_pTransaction->m_szCodeClient,
				p_pTransaction->m_szCodeClientPaitype,
				(int)p_pTransaction->m_ePaiType,
				szTimeBuffer,
				p_pTransaction->m_chEtat,
				p_pTransaction->m_CodeErreur,
				p_pTransaction->m_fltPrixTTC,
				p_pTransaction->m_fltPrixHT,
				p_pTransaction->m_szDevise,
				p_pTransaction->m_chCaddie,
				p_pTransaction->m_szRefMarchandAppel);

		sprintf(szRequete,"INSERT INTO %s (%s) VALUES(%s)",glb_szNomTable__Transactions,szFields,szValues);
		DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte I Requete=\n%s\n",szRequete);

		//	Ouverture du curseur
		ErreurCode=OpenDBCurseur(glb_pDBInfo,*glb_piGravite);
		if	(IsError(ErreurCode))
		{
			//	Erreur Ouverture curseur
			DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
		}
		else
		{
			//	Parse de la requete
			DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Acte I avant OPARSE\n");
			if(oparse(&glb_pDBInfo->m_cda,szRequete,-1,0,2))
			{
				//	Ereur Parse
				ErreurCode=MakeErrorCode(FN_Transaction_AjouterNouvelle,*glb_piGravite,ERROR__OPARSE);
				DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
			};

			DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Acte I aprs OPARSE\n");
			if	(!IsError(ErreurCode))
			{
				//	Execution de la requete
				DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Acte I avant OEXEC\n");
				if(oexec(&glb_pDBInfo->m_cda))
				{
					//	Erreur execution requete
					ErreurCode=MakeErrorCode(FN_Transaction_AjouterNouvelle,*glb_piGravite,ERROR__OXEC);
					DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
				};
				DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Acte I aprs OEXEC\n");
			};
			ErreurCode=CloseDBCurseur(glb_pDBInfo,*glb_piGravite,ErreurCode);
		};
	};
	//	---------------------------------------------------
	//	--------------------- Acte II: Ajouter les Produits
	if	(!IsError(ErreurCode))
	{
		char	szFields[]="CodeTransaction,CodeMarchand,CodeProduit,PrixTTC,CodeTVA,Quantite,RefMarchandAppel,ParamRetours, ParamRetours2";
		DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II p_iProduitsNb=%d\n",p_iProduitsNb);

		//	On va ajouter chaque produit
		for(i=0;i<p_iProduitsNb;i++)
		{
			//	Formatage de la requete
			sprintf(szValues,"'%s','%s','%s',%.2f,%d,%d,'%s','%s', '%s'",
					p_pTransaction->m_szCode,
					p_pProduits[i].m_szCodeMarchand,
					p_pProduits[i].m_szCodeProduit,
					p_pProduits[i].m_fltPrixTTC,
					p_pProduits[i].m_iCodeTVA,
					p_pProduits[i].m_iQuantite,
					p_pProduits[i].m_szRefMarchandAppel,
					p_pProduits[i].m_szParamRetours,
					p_pProduits[i].m_szParamRetours2);

			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II i=%d\n",i);
			sprintf(szRequete,"INSERT INTO %s (%s) VALUES(%s)",
					glb_szNomTable__TransactProduits,
					szFields,
					szValues);
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II Code Transaction=%s\n",p_pTransaction->m_szCode);
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II m_szCodeMarchand=%s\n",p_pProduits[i].m_szCodeMarchand);
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II m_szCodeProduit=%s\n",p_pProduits[i].m_szCodeProduit);
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II m_fltPrixTTC=%.2f\n",p_pProduits[i].m_fltPrixTTC);
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II m_iCodeTVA=%d\n",p_pProduits[i].m_iCodeTVA);
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II m_fltQuantite=%d\n",p_pProduits[i].m_iQuantite);
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II m_szRefMarchandAppel=%s\n",p_pProduits[i].m_szRefMarchandAppel);
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II m_szParamRetours=%s\n",p_pProduits[i].m_szParamRetours);
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II m_szParamRetours2=%s\n",p_pProduits[i].m_szParamRetours2);
			
			DebugTraceAndFlushIFDM_1P("Transaction_AjouterNouvelle() Acte II Requete=\n%s\n",szRequete);

			//	Ouverture du curseur
			ErreurCode=OpenDBCurseur(glb_pDBInfo,*glb_piGravite);
			if	(!IsError(ErreurCode))
			{
				//	Parse de la requete
				DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Acte II avant OPARSE\n");
				if(oparse(&glb_pDBInfo->m_cda,szRequete,-1,0,2))
				{
					ErreurCode=MakeErrorCode(FN_Transaction_AjouterNouvelle,*glb_piGravite,ERROR__OPARSE);
					DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
				};

				DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Acte II aprs OPARSE\n");
				if	(!IsError(ErreurCode))
				{
					//	Exec de la requete
					DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Acte II avant OEXEC\n");
					if(oexec(&glb_pDBInfo->m_cda))
					{
						ErreurCode=MakeErrorCode(FN_Transaction_AjouterNouvelle,*glb_piGravite,ERROR__OXEC);
						DebugTraceErrorMacro(ErreurCode,glb_pDBInfo);
					};
					DebugTraceAndFlushIFDM("Transaction_AjouterNouvelle() Acte II aprs OEXEC\n");
				};
				ErreurCode=CloseDBCurseur(glb_pDBInfo,*glb_piGravite,ErreurCode);
			};
		};
	};
	DebugTraceAndFlushIFDM("Fin Transaction_AjouterNouvelle()\n");
	return ErreurCode;
};
