/******************************************************************************
FILE:               O2CI8Column.h
LANGUAGE:           Objective-C
SYSTEM:             None
USER-INTERFACE:     None
DESCRIPTION
    $Header$
    This is the definition of the O2CI8Column class.
    The class O2CI8Column is xxxxxx.

	Note: to instanciate this class, clients should use:
		+[O2CI8Parameter parameterWithHandle:]
	with a handle to a parameter of type OCI_PTYPE_VIEW.

AUTHORS
    <PJB>  Pascal J. Bourguignon  <pjb@imaginet.fr>
MODIFICATIONS
    $Log$
    1999/08/02 Creation.
BUGS
    - 
LEGAL
    Copyright Pascal J. Bourguignon 1999 - 1999

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; see the file COPYING.LIB.
    If not, write to the Free Software Foundation,
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#ifndef __O2CI8Column_h__
#define __O2CI8Column_h__
#include <AppKit/AppKit.h>
#include <Foundation/Foundation.h>
#include <O2CI8Parameter.h>

@interface O2CI8Column:O2CI8Parameter
{
}

// NSObject methods:

	// None overriden.


// O2CI8Parameter methods:

	// None overriden.

    
// O2CI8Column methods:

	-(ub2)dataSize;
	-(ub2)dataType;
	-(NSString*)name;
	-(ub1)precision; // 0 ==> NULL.
	-(sb1)scale;     // -127 ==> NULL.
	-(ub1)isNull;    // 0 <=> NULL is not permited.
	-(NSString*)typeName;  // only for SQLT_NTY and SQLT_REF?
	-(NSString*)schemaName;
	-(void/*OCIRef*/*)refTdo; // only with the object option.
	-(ub2)charsetId;
	-(ub1)charsetForm;


@end //O2CI8Column;

#endif /*__O2CI8Column_h__*/

/*** O2CI8Column.h -- 1999/08/02 01:44:44 -- <PJB> ***/
