/******************************************************************************
FILE:               O2CI8Column.m
LANGUAGE:           Objective-C
SYSTEM:             None
USER-INTERFACE:     None
DESCRIPTION
    $Header$
    This is the imeplemtation of the O2CI8Column class.
    The class O2CI8Column is xxxxxx.
    The implementation of the class O2CI8Column xxxxxxx.

AUTHORS
    <PJB>  Pascal J. Bourguignon  <pjb@imaginet.fr>
MODIFICATIONS
    $Log$
    1999/08/02 Creation.
BUGS
    - 
LEGAL
    Copyright Pascal J. Bourguignon 1999 - 1999

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; see the file COPYING.LIB.
    If not, write to the Free Software Foundation,
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#include <O2CI8Column.h>
#include <O2CI8Error.h>
#include <Oracle8Utilities.h>


@implementation O2CI8Column

    static const char* rcsid="$Id";

// NSObject methods:

	// None overriden.


// O2CI8Parameter methods:

	// None overriden.

    
// O2CI8Column methods:

	-(ub2)dataSize
	{
		ub2 value;
		if([self getUb2:&value attribute:OCI_ATTR_DATA_SIZE
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}	
	}//dataSize;


	-(ub2)dataType
	{
		ub2 value;
		if([self getUb2:&value attribute:OCI_ATTR_DATA_TYPE
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}	
	}//dataType;


	-(NSString*)name
	{
		NSString* value;
		if([self getString:&value attribute:OCI_ATTR_NAME
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(nil);
		}	
	}//name;


	-(ub1)precision // 0 ==> NULL.
	{
		ub1 value;
		if([self getUb1:&value attribute:OCI_ATTR_PRECISION
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}	
	}//precision;


	-(sb1)scale     // -127 ==> NULL.
	{
		ub1 value;
		if([self getUb1:&value attribute:OCI_ATTR_SCALE
				from:CURRENT_METHOD]){
			return((sb1)value);
		}else{
			return(0);
		}	
	}//scale;


	-(ub1)isNull    // 0 <=> NULL is not permited.
	{
		ub1 value;
		if([self getUb1:&value attribute:OCI_ATTR_IS_NULL
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}	
	}//isNull;


	-(NSString*)typeName  // only for SQLT_NTY and SQLT_REF?
	{
		NSString* value;
		if([self getString:&value attribute:OCI_ATTR_TYPE_NAME
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(nil);
		}	
	}//typeName;


	-(NSString*)schemaName
	{
		NSString* value;
		if([self getString:&value attribute:OCI_ATTR_SCHEMA_NAME
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(nil);
		}	
	}//schemaName;


	-(void/*OCIRef*/*)refTdo
	{
		NOT_IMPLEMENTED_YET;
		return(nil);
	}//refTdo;



	-(ub2)charsetId
	{
		ub2 value;
		if([self getUb2:&value attribute:OCI_ATTR_CHARSET_ID
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}	
	}//charsetId;


	-(ub1)charsetForm
	{
		ub1 value;
		if([self getUb1:&value attribute:OCI_ATTR_CHARSET_FORM
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}	
	}//charsetForm;


	


@end //O2CI8Column;

/*** O2CI8Column.m -- 1999/08/02 01:44:44 -- <PJB> ***/

