/******************************************************************************
FILE:               O2CI8Error.m
LANGUAGE:           Objective-C
SYSTEM:             None
USER-INTERFACE:     None
DESCRIPTION
    $Header$
    This is the implementation of the O2CI8Error class.
    The class O2CI8Error is xxxxxx.
    The implementation of the class O2CI8Error xxxxxxx.

AUTHORS
    <PJB>  Pascal J. Bourguignon  <pjb@imaginet.fr>
MODIFICATIONS
    $Log$
    1999/07/27 Creation.
BUGS
    - It's not implemented yet.
LEGAL
    Copyright Pascal J. Bourguignon 1999 - 1999

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; see the file COPYING.LIB.
    If not, write to the Free Software Foundation,
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#include <O2CI8Error.h>
#include <O2CI8Environment.h>
#include <Oracle8Utilities.h>


@implementation O2CI8Error

    static const char* rcsid="$Id";


// NSObject methods:

    -(id)init
    {
        self=[super init];
        if(self!=nil){
            handleType=OCI_HTYPE_ERROR;
            handleIsValid=[self processErrorCode:OCIHandleAlloc(
            	                    [[O2CI8Environment instance]handle],
									&handle,handleType,0,(dvoid*)0)
								from:CURRENT_METHOD_AND(@"/OCIHandleAlloc")
								mayRaise:NO];
        }
        return(self);
    }//init;


    -(void)dealloc
    {
        // RELEASES.
        [super dealloc];
    }//dealloc;


// O2CI8Object methods:


    
// O2CI8Error methods:

	-(NSString*)getMessageAndOracle8Code:(sb4*)oraCode atIndex:(ub4)oneBasedIndex
	{
		text cMessage[512];
		sword ociResult=OCIErrorGet(handle,oneBasedIndex,(text*)0,oraCode,
								cMessage,(ub4)sizeof(cMessage),handleType);
		switch(ociResult){
		case OCI_SUCCESS:
			return([NSString stringWithCString:cMessage]);
		case OCI_NO_DATA:
			return(nil);
		default:
			NSLog(NSLocalizedStringFromTableInBundle(\
					@"OCIErrorGet returned result=%d.\n",@"O2CI8",[self bundle],\
					@"Error message when we cannot get an error message."),
				ociResult);
			return(nil);
		}
	}//getMessageAndOracle8Code:atIndex:;



@end //O2CI8Error;

/*** O2CI8Error.m -- 1999/07/27 06:35:55 -- <PJB> ***/

