/******************************************************************************
FILE:               O2CI8ServerConnection.h
LANGUAGE:           Objective-C
SYSTEM:             None
USER-INTERFACE:     None
DESCRIPTION
    $Header$
    This is the definition of the O2CI8ServerConnection class.
    The class O2CI8ServerConnection is xxxxxx.

AUTHORS
    <PJB>  Pascal J. Bourguignon  <pjb@imaginet.fr>
MODIFICATIONS
    $Log$
    1999/07/27 Creation.
BUGS
    - It's not implemented yet.
LEGAL
    Copyright Pascal J. Bourguignon 1999 - 1999

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; see the file COPYING.LIB.
    If not, write to the Free Software Foundation,
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#ifndef __O2CI8ServerConnection_h__
#define __O2CI8ServerConnection_h__
#include <O2CI8Object.h>

@interface O2CI8ServerConnection:O2CI8Object
{
	BOOL                isAttached;
}

// NSObject methods:

    -(id)init;
		/*
			POST:       ![self isAttached].
		*/

    -(void)dealloc;


// O2CI8Object methods:


    
// O2CI8ServerConnection methods:


	-(BOOL)attachToDatabase:(NSString*)connectString;
		/*
			PRE:        ![self isAttached] && [self handleIsValid].

			RAISE:      O2CI8Object_eInvalidState when [self isAttached].
			RAISE:      O2CI8Object_eInvalidHandle when ![self handleIsValid].

			connectString:
						when nil, attach to the default server, 
						otherwise specifies the server.

			RETURN:     whether the database is attached successfully.

			NOTE:       even when the database is attached successfully,
						there can be some informative messages in errorMessages.
		*/


	-(void)detach;
		/*
			PRE:        [self isAttached].
			RAISE:      O2CI8Object_eInvalidState when ![self isAttached].
			POST:       ![self isAttached].
		*/


	-(BOOL)isAttached;
		/*
			RETURN:    whether this server connection is attached to a server.
			NOTE:      [x isAttached] ==> [x handleIsValid].
	    */


@end //O2CI8ServerConnection;

#endif /*__O2CI8ServerConnection_h__*/

/*** O2CI8ServerConnection.h -- 1999/07/27 06:35:59 -- <PJB> ***/







