/******************************************************************************
FILE:               O2CI8ServerConnection.m
LANGUAGE:           Objective-C
SYSTEM:             None
USER-INTERFACE:     None
DESCRIPTION
    $Header$
    This is the implementation of the O2CI8ServerConnection class.
    The class O2CI8ServerConnection is xxxxxx.
    The implementation of the class O2CI8ServerConnection xxxxxxx.

AUTHORS
    <PJB>  Pascal J. Bourguignon  <pjb@imaginet.fr>
MODIFICATIONS
    $Log$
    1999/07/27 Creation.
BUGS
    - It's not implemented yet.
LEGAL
    Copyright Pascal J. Bourguignon 1999 - 1999

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; see the file COPYING.LIB.
    If not, write to the Free Software Foundation,
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#include <O2CI8ServerConnection.h>
#include <O2CI8Environment.h>
#include <O2CI8Error.h>
#include <Oracle8Utilities.h>


@implementation O2CI8ServerConnection

    static const char* rcsid="$Id";

// NSObject methods:

    -(id)init
    {
        self=[super init];
        if(self!=nil){
            handleType=OCI_HTYPE_SERVER;
            handleIsValid=[self processErrorCode:OCIHandleAlloc(
            	                    [[O2CI8Environment instance]handle],
									&handle,handleType,0,(dvoid*)0)
								from:CURRENT_METHOD_AND(@"/OCIHandleAlloc")
								mayRaise:NO];
			error=[[O2CI8Error alloc]init];
			isAttached=NO;
        }
        return(self);
    }//init;



    -(void)dealloc
    {
        [super dealloc];
    }//dealloc;


// O2CI8Object methods:


    
// O2CI8ServerConnection methods:

	-(BOOL)attachToDatabase:(NSString*)connectString
	{
		sword ociResult;
		if(!handleIsValid){
			[NSException raise:O2CI8Object_eInvalidHandle 
					format:@"-[O2CI8ServerConnection attachToDatabase]"];
		}
		if([self isAttached]){
			[NSException raise:O2CI8Object_eInvalidState
					format:@"-[O2CI8ServerConnection attachToDatabase]"];
		}
		if(connectString==nil){
			ociResult=OCIServerAttach(handle,[error handle],
							(text*)0,0,OCI_DEFAULT);
		}else{
			ociResult=OCIServerAttach(handle,[error handle],
							(text*)[connectString cString],
							[connectString cStringLength],OCI_DEFAULT);
		}
		isAttached=[self processErrorCode:ociResult
				from:CURRENT_METHOD_AND(@"/OCIHandleAlloc")];
		return(isAttached);
	}//attachToDatabase:;


	-(void)detach
	{
		if(![self isAttached]){
			[NSException raise:O2CI8Object_eInvalidState
					format:@"-[O2CI8ServerConnection detach]"];
		}
		if(!handleIsValid){
			[NSException raise:O2CI8Object_eInvalidHandle 
					format:@"-[O2CI8ServerConnection attachToDatabase]"];
		}
		isAttached=NO;
		[self processErrorCode:OCIServerDetach(handle,[error handle],OCI_DEFAULT)
				from:CURRENT_METHOD_AND(@"/OCIServerDetach")];
	}//detach;


	-(BOOL)isAttached
	{
		return(isAttached);
	}//isAttached;



@end //O2CI8ServerConnection;

/*** O2CI8ServerConnection.m -- 1999/07/27 06:36:00 -- <PJB> ***/

