/******************************************************************************
FILE:               O2CI8Table.m
LANGUAGE:           Objective-C
SYSTEM:             None
USER-INTERFACE:     None
DESCRIPTION
    $Header$
    This is the implementation of the O2CI8Table class.
    The class O2CI8Table is xxxxxx.
    The implementation of the class O2CI8Table xxxxxxx.

AUTHORS
    <PJB>  Pascal J. Bourguignon  <pjb@imaginet.fr>
MODIFICATIONS
    $Log$
    1999/08/02 Creation.
BUGS
    - 
LEGAL
    Copyright Pascal J. Bourguignon 1999 - 1999

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; see the file COPYING.LIB.
    If not, write to the Free Software Foundation,
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#include <O2CI8Table.h>
#include <O2CI8Error.h>
#include <Oracle8Utilities.h>


@implementation O2CI8Table

    static const char* rcsid="$Id";

// O2CI8Table methods:

	-(ub4)rdba
	{
		ub4 value;
		if([self getUb4:&value attribute:OCI_ATTR_RDBA from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}
	}//rdba;


	-(sword)tableSpace
	{
		sword value;
		if([self getWord:&value attribute:OCI_ATTR_TABLESPACE
				from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}
	}//tableSpace;


	-(ub1)isClustered
	{
		ub1 value;
		if([self getUb1:&value attribute:OCI_ATTR_CLUSTERED from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}
	}//isClustered;


	-(ub1)isPartitioned
	{
		ub1 value;
		if([self getUb1:&value attribute:OCI_ATTR_PARTITIONED
					from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}
	}//isPartitioned;


	-(ub1)isIndexOnly
	{
		ub1 value;
		if([self getUb1:&value attribute:OCI_ATTR_INDEX_ONLY from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}
	}//isIndexOnly;


@end //O2CI8Table;

/*** O2CI8Table.m -- 1999/08/02 01:44:38 -- <PJB> ***/

