/******************************************************************************
FILE:               O2CI8View.m
LANGUAGE:           Objective-C
SYSTEM:             None
USER-INTERFACE:     None
DESCRIPTION
    $Header$
    This is the implementation of the O2CI8View class.
    The class O2CI8View is xxxxxx.
    The implementation of the class O2CI8View xxxxxxx.

AUTHORS
    <PJB>  Pascal J. Bourguignon  <pjb@imaginet.fr>
MODIFICATIONS
    $Log$
    1999/08/02 Creation.
BUGS
    - It's not implemented yet.
LEGAL
    Copyright Pascal J. Bourguignon 1999 - 1999

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; see the file COPYING.LIB.
    If not, write to the Free Software Foundation,
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#include <O2CI8View.h>
#include <O2CI8Error.h>
#include <Oracle8Utilities.h>

@implementation O2CI8View

    static const char* rcsid="$Id";

// NSObject methods:

	// None overriden.


// O2CI8Object methods:

	// None overriden.


// O2CI8Parameter methods:

	// None overriden.

    
// O2CI8View methods:

	-(ub4)objectId
	{
		ub4 value;
		if([self getUb4:&value attribute:OCI_ATTR_OBJID from:CURRENT_METHOD]){
			return(value);
		}else{
			return(0);
		}	
	}//objectId;


	-(ub2)numColumn
	{
		ub2 num;
		if([self getUb2:&num attribute:OCI_ATTR_NUM_COLS from:CURRENT_METHOD]){
			return(num);
		}else{
			return(0);
		}
	}//numColumn;


	-(O2CI8List*)getColumnList
	{
		dvoid* columnList;
		if([self getDVoidP:&columnList attribute:OCI_ATTR_LIST_COLUMNS 
				from:CURRENT_METHOD]){
			return(columnList);
		}else{
			return(nil);
		}
	}//getColumnList;


	-(NSArray*)getColumns
	{
		NSAssert((([[self getColumnList]listType]==OCI_LTYPE_COLUMN)
				||([[self getColumnList]listType]==0/*SEE: listType!*/)),
			@"The OCI_ATTR_LIST_COLUMNS attribute should be "
			@"a list of OCI_LTYPE_COLUMN!");
		return([[self getColumnList]getParameters]);
	}//getColumns;


  

@end //O2CI8View;

/*** O2CI8View.m -- 1999/08/02 01:44:36 -- <PJB> ***/

