/******************************************************************************
FILE:               Oracle8Expression.h
LANGUAGE:           Objective-C
SYSTEM:             GNUstep
USER-INTERFACE:     None
DESCRIPTION

    This module defines the SQL expressions specific to the Oracle8 Adaptor.

AUTHORS
    <PJB> Pascal J. Bourguignon <pjb@imaginet.fr>
MODIFICATIONS
    1999/07/24 Creation.
BUGS
    - ...
LEGAL
    Copyright Pascal J. Bourguignon 1999 - 1999
	Copyright Software Builders     1999 - 1999

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; see the file COPYING.LIB.
    If not, write to the Free Software Foundation,
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#ifndef __Oracle8SQLExpression_h__
#define __Oracle8SQLExpression_h__

#include <eoaccess/eoaccess.h>  // Let's leave  the  compiler  handle 
                                // intelligently pre-compiled headers!


// ------------------------------------------------------------------------ //

@interface Oracle8SQLExpression:EOSQLExpression

// NSObject methods:

    // None overriden.


// EOSQLExpression methods:

	+(Class)selectExpressionClass;


// Oracle8SQLExpression methods:

    // None.


@end // Oracle8SQLExpression;


// ------------------------------------------------------------------------ //

@interface Oracle8SelectSQLExpression:EOSelectSQLExpression


// NSObject methods:

    // None overriden.


// EOSelectSQLExpression methods:

	-(NSString*)lockClause;


// Oracle8SelectSQLExpression methods:

    // None.


@end // Oracle8SelectSQLExpression;


// ------------------------------------------------------------------------ //

#endif /* __Oracle8SQLExpression_h__ */
/*** Oracle8SQLExpression.h -- 1999/07/24 04:44:50 -- PJB ***/
