/******************************************************************************
FILE:               Oracle8Utilities.h
LANGUAGE:           Objective-C
SYSTEM:             GNUstep
USER-INTERFACE:     None
DESCRIPTION

    This module exports some utilities macros and functions for the
	Oracle8Adaptor.

AUTHORS
    <PJB> Pascal J. Bourguignon <pjb@imaginet.fr>
MODIFICATIONS
    1999/07/24 Creation.
BUGS
	- ...
LEGAL
    Copyright Pascal J. Bourguignon 1999 - 1999
	Copyright Software Builders     1999 - 1999

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; see the file COPYING.LIB.
    If not, write to the Free Software Foundation,
    59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/
#ifndef __Oracle8Utilities_h__
#define __Oracle8Utilities_h__
#include <Foundation/Foundation.h>


	extern NSBundle* Oracle8Utilities_Bundle(void);
		/*
			RETURN:     The bundle from which the Oracle8Adaptor class 
						has been loaded.
		*/

// If self->isa isn't a class, then it's a metaclass and self is a class.

#define NOT_IMPLEMENTED_YET \
		NSLog(@"%c[%@ %@] is not implemented yet.",\
			CLS_ISCLASS(self->isa)?'-':'+',\
			NSStringFromClass([self class]),\
			NSStringFromSelector(_cmd));


#define CURRENT_METHOD \
		[NSString stringWithFormat:@"%c[%@ %@]",\
			CLS_ISCLASS(self->isa)?'-':'+',\
			NSStringFromClass([self class]),\
			NSStringFromSelector(_cmd)]

#define CURRENT_METHOD_AND(p) \
		[NSString stringWithFormat:@"%c[%@ %@]%@",\
			CLS_ISCLASS(self->isa)?'-':'+',\
			NSStringFromClass([self class]),\
			NSStringFromSelector(_cmd),\
			(p)]

#define DECLARE_SYMBOL(p)  NSString* p=@ ## #p;



#endif // __Oracle8Utilities_h__
/*** Oracle8Utilities.h -- 1999/07/24 07:36:13 -- PJB ***/


